local addonName, addonTable = ...; 

ForTheFaction = {}
-- Setting player faction to whatever faction you represent.
local playerfaction = UnitFactionGroup("player")

-- Defaulting to shouting being available.
local canshoutBuff = true
local canshoutPvP = true
local canshoutAchievement = true
local canshoutEligible = true
-- List of the Buffs that trigger For the Faction
local buffs = {
    ["Time Warp"] = true,
    ["Bloodlust"] = true,
    ["Heroism"] = true,
    ["Ancient Hysteria"] = true,
    ["Netherwinds"] = true,
}

-- Function to show your Faction Pride.
function pride()
	if canshoutEligible then
	if playerfaction == 'Alliance' then -- Alliance Scum Detected!
		DoEmote("forthealliance","none") -- FOR THE ALLIANCE!
	else
		if playerfaction == 'Horde' then -- Horde Scum Detected!
			DoEmote("forthehorde","none") -- FOR THE ALLIANCE!
		end
	end
	end
end

-- Function to check if any of the buffs is applied to player
function checkbuff()
	for buff in pairs(buffs) do
		if UnitBuff("player", buff) then
			return true
		end
	end
	return false
end

-- Function to check if Player is eligible to shout based on quests complete
function eligibilityCheck()
	local playerclass = UnitClass("player")
	if ForTheFactionOptions["QuestCompletionBasedPride"] then
		if playerclass == "Death Knight" then
			if IsQuestFlaggedCompleted(13188) or IsQuestFlaggedCompleted(13189) then
				canshoutEligible = true
			else
				canshoutEligible = false
			end
		else
			if playerclass == "Demon Hunter" then
				if IsQuestFlaggedCompleted(39689) then
					canshoutEligible = true
				else
					canshoutEligible = false
				end
			else
				canshoutEligible = true
			end
		end
	else
		canshoutEligible = true
	end
end

-- Creating a frame and registering the UNIT_AURA event to it.
local frameBuff = CreateFrame("Frame", "FTFBuffFrame")
frameBuff:RegisterEvent("UNIT_AURA")

-- Buff Pride
-- Running the function when OnEvent triggers on frame.
frameBuff:SetScript("OnEvent", function(self, event, ...)
	-- Checking Options to see if we even want to do this.
	if ForTheFactionOptions["FTFBuffPride"] then
		local unit = ...
		
		-- We don't care unless it's YOU.
		if unit ~= "player" then
			return
		end	
		-- Checking if canshout is true and if checkbuff returns true, if ture we shout and set canshout to false. 
		if canshoutBuff then
			if checkbuff() then
				pride()
				canshoutBuff = false
			end
		else
			-- If Canshout failed, we'll checkbuff to see if it should've failed.
			if checkbuff() == false then
			canshoutBuff = true
			end
		end
	else
		return
	end
end)

-- Honorable Kill Pride
local framePvP = CreateFrame("Frame", "FTFPvPFrame")
framePvP:RegisterEvent("PLAYER_PVP_KILLS_CHANGED")

framePvP:SetScript("OnEvent", function(self, event, ...)
	-- Checking Options to see if we even want to do this.
	if ForTheFactionOptions["PvPPride"] then
		if canshoutPvP then
			pride()
			canshoutPvP = false -- Remdinding us that we shouted.
			local timerPvP = C_Timer.After(45, function() canshoutPvP = true end); -- Forgetting about the whole shout thing 45 seconds later.
		end
	else
		return
	end
end)

-- Level Up Pride
local frameLevelUp = CreateFrame("Frame", "FTFLevelUpFrame")
frameLevelUp:RegisterEvent("PLAYER_LEVEL_UP")

frameLevelUp:SetScript("OnEvent", function(self, event, ...)
	-- Checking Options to see if we even want to do this.
	if ForTheFactionOptions["LevelUpPride"] then
		pride()
	else
		return
	end
end)

-- Achievement Pride
local frameAchievement = CreateFrame("Frame", "FTFAchievementFrame")
frameAchievement:RegisterEvent("ACHIEVEMENT_EARNED")

frameAchievement:SetScript("OnEvent", function(self, event, ...)
	-- Checking Options to see if we even want to do this.
	if ForTheFactionOptions["AchievementPride"] then
		if canshoutAchievement then
			pride()
			canshoutAchievement = false -- Remdinding us that we just shouted.
			local timerAchievement = C_Timer.After(15, function() canshoutAchievement = true end); -- Forgetting about the whole shout thing 15 seconds later.
		end
	else
		return
	end
end)

-- Roleplay Pride
local frameQuest = CreateFrame("Frame", "FTFQuestFrame")
frameQuest:RegisterEvent("QUEST_FINISHED")

frameQuest:SetScript("OnEvent", function(self, event, ...)
	if ForTheFactionOptions["QuestCompletionBasedPride"] then
		eligibilityCheck()
	else
		canshoutEligible = true
	end
end)

-- Adds the /forthe and /ft slashcommands for faction-free commands.
SLASH_FORTHEFACTION1, SLASH_FORTHEFACTION2 = '/forthe', '/ft';
function SlashCmdList.FORTHEFACTION(msg, editbox)
eligibilityCheck()
pride()
end